// About.java
/* A Java class for
 * LineImpedance.java
 * Electromagnetic Transmission Line Applet
 * Applet without Smith Chart - Prepared by Umberto Ravaioli 
 * for 6th edition of Fundamentals of Applied Electromagnetics Book
 * May 2009 - All Rights Reserved
 */   


import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.font.*;
import java.net.URL;
import java.text.*;
import java.util.*;
import java.util.Map;
import java.util.Hashtable;
import java.util.jar.Attributes;
import java.awt.image.BufferedImage;
//import java.io.IOException;
import javax.imageio.ImageIO;


public class Instructions extends Panel {
    
    //private static final Color bgcolor = new Color(236,236,236);
    private static final Color bgcolor = Color.white;
    
    public TextField epsilon;
    private Paint paint;
    
    private Image im;
    private Graphics buf;
    private BufferedImage figure;

    //Mod1State state;
    public Button bupdate;
  
    public Instructions(){
	super();
        //this.state = state;
	setLayout(null);
	setBackground(bgcolor);
	bupdate = new Button("CLOSE");
        bupdate.setBackground(new Color(240,240,255));
	add(bupdate);
        //int buttonx = 410;
        //int buttony = 440;
        int buttonx = 625;
        int buttony = 255;
        int buttonwide = 70;
        int buttonheight = 27;
        
        bupdate.setBounds(buttonx,buttony,buttonwide,buttonheight);	
        Panel ps7 = new Panel();
	    ps7.setBackground(Color.lightGray);
	    add(ps7);
	    ps7.setBounds(buttonx-1,buttony-1,buttonwide+2,buttonheight+2);
	    
	Panel ps8 = new Panel();
	    ps8.setBackground(Color.black);
	    add(ps8);
	    ps8.setBounds(buttonx-2,buttony-2,buttonwide+4,buttonheight+4);	
    }
    
    public void paint(Graphics g){
            
	    if(im == null){
		im = createImage(getSize().width,getSize().height);
		buf = im.getGraphics();
		drawCanvas(buf);
	    }
	    else{
		drawCanvas(buf);
	    }
	    g.drawImage(im,0,0,null);
    }
	
	//Addition to reduce flicker new routine
    public void update(Graphics g){		// added to avoid clearing
            paint(g);
    }
    
    public void clear(){
	    this.getGraphics().clearRect(0,0,getSize().width,getSize().height);
	    repaint();
    }
    
    public void drawCanvas(Graphics g){
        FontMetrics fm;
        Graphics2D g2d = (Graphics2D)g;
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                             RenderingHints.VALUE_ANTIALIAS_ON);        
        g.clearRect(0,0,getSize().width-1,getSize().height-1);

        //g.setFont(font_one);
        //fm = g.getFontMetrics();

        //boolean saveOldFlag = MaestroG.useBiggerFont;
        //MaestroG.useBiggerFont = false;
        
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,16f));
        g.setFont(new Font("SanSerif",Font.BOLD,16));
        

        try {
            figure = ImageIO.read(getClass().getResource("mod9.7.gif"));
        } catch (IOException e) {
            e.printStackTrace();
        }


        g.drawString("Instructions", 20,25);
        
        //g.setFont(state.ttfFont.deriveFont(14f));
        //g.setFont(new Font("SanSerif",Font.PLAIN,14));
        //g.drawString("This module can accomodate linearly polarized plane "+
        //            "waves in both lossy and lossless media.",15,50);
        String s;
        int nextX;

        //g.drawImage(figure,450,50,this);
        g.drawImage(figure,750,50,this);

        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        g.drawString("Assumptions", 15,50);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        int deltaY = 18;
        //ASSUMPTIONS
        s = "\u2022 array elements are identical";
        nextX = STR.displayString(s,g,15,70);
        s = "\u2022 array elements fed with equal amplitudes and phases";
        nextX = STR.displayString(s,g,15,70+deltaY);
        s = "\u2022 array elements equally spaced";
        nextX = STR.displayString(s,g,15,70+2*deltaY);

        g.setColor(Color.red);
        g.setFont(new Font("SanSerif",Font.BOLD,15));

        int newY = 70+3*deltaY+10;
        g.drawString("Input",15,newY);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        //INPUT
        newY += 18;
        s = "\u2022 Number of array elements "+STR.ITAL+"N"+STR.ENDITAL+
            " (1 \u2264 "+STR.ITAL+"N"+STR.ENDITAL+" \u2264 6)";
        nextX = STR.displayString(s,g,15,newY);
        s = "\u2022 Type of element";
        nextX = STR.displayString(s,g,15,newY+deltaY);
        s = "      - Dipole with length \u03bb/2, or";
        nextX = STR.displayString(s,g,15,newY+2*deltaY);
        s = "      - Dish with diameter = 2\u03bb.";
        nextX = STR.displayString(s,g,15,newY+3*deltaY);
        s = "\u2022 Interelement spacing (0.25\u03bb \u2264 "+
            STR.ITAL+"d"+STR.ENDITAL+" \u2264 \u03bb)";
        nextX  = STR.displayString(s,g,15,newY+4*deltaY);

       //OUTPUT
        g.setColor(Color.red);
        //g.setFont(state.ttfFont.deriveFont(Font.BOLD,15f));
        g.setFont(new Font("SanSerif",Font.BOLD,15));
        //newY = newY+6*deltaY+40;
        newY = 50;
        g.drawString("Displayed Information", 425,newY);
        g.setColor(Color.black);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        newY += 20;
        s = "\u2022 Element radiation pattern F"+STR.SUB+"e"+STR.ENDSUB+
            "(\u03b8)";
        nextX = STR.displayString(s,g,425,newY);
        s = "\u2022 Array Pattern F"+STR.SUB+"a"+STR.ENDSUB+"(\u03b8)";
        nextX = STR.displayString(s,g,425,newY+deltaY);
        s = "\u2022 Antenna array pattern F(\u03b8) = F"+
            STR.SUB+"e"+STR.ENDSUB+"(\u03b8)F"+
            STR.SUB+"a"+STR.ENDSUB+"(\u03b8)";
        nextX = STR.displayString(s,g,425,newY+2*deltaY);
        s = "\u2022 Associated directivities and beamwidths";
        nextX = STR.displayString(s,g,425,newY+3*deltaY);

        drawCopyRight(g);

        //MaestroG.useBiggerFont = saveOldFlag;

    }


    public void drawCopyRight(Graphics g) {
        int deltaY = 20;
        int startingY = getSize().height - 70;
        int startingX = 0;
        FontMetrics fm;
        g.setColor(Color.black);
        g.setColor(Color.black);
        //g.setFont(normalfont14);
        //g.setFont(state.ttfFont.deriveFont(14f));
        g.setFont(new Font("SanSerif",Font.PLAIN,14));
        fm = g.getFontMetrics();
        g.drawString("Applet Design: Umberto Ravaioli",
                     startingX+15,startingY+deltaY);
        
        //MaestroG.superscripter("Interactive Java","TM"," platform:  www.amanogawa.com",
        //                       g,14,startingX,startingY+2*deltaY);
        String s = "Interactive Java"+STR.SUP+"TM"+STR.ENDSUP+
            " platform:  www.amanogawa.com";
        int nextX = STR.displayString(s,g,startingX+15,startingY+2*deltaY);
        int lineLength = fm.stringWidth("Interactive JavaTM platform:  www.amanogawa.com");
        lineLength+= 10;

        //g.setFont(state.ttfFont.deriveFont(14f));
        g.drawString("All Rights Reserved",startingX+15,startingY+3*deltaY);
        g.drawLine(startingX,startingY+5,
                   startingX+15+lineLength+10,startingY+5);
        g.drawLine(startingX+15+lineLength+10,startingY+5,
                   startingX+15+lineLength+10,startingY+4*deltaY);
    }

//----------------------------------------------------------------------------------------    
}//End
    

